﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class CameraRatio : MonoBehaviour
{
    // Use this for initialization
    [SerializeField] private float currentAspect;
    [SerializeField] private float defaultAspectRatio = 0.5625F;

    private new Camera camera;

    void OnEnable()
    {
        AspectRatio();
    }

    void OnDisable()
    {
        ResetAspectRatio();
    }

    public void AspectRatio()
    {
        if (camera.aspect != defaultAspectRatio)
            camera.aspect = defaultAspectRatio;
    }

    public void ResetAspectRatio()
    {
        if (camera.aspect != currentAspect)
            camera.aspect = currentAspect;
    }

    private void Awake()
    {
        camera = GetComponent<Camera>();
        currentAspect = camera.aspect;
    }
}
