using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CanvasSettings : MonoBehaviour
{
    [SerializeField] private List<RectTransform> transformPos;

    [SerializeField] private List<float> posYCoeficient;
    private RectTransform canvasRect, rectTransform;
    private float imageHeight;

    protected void Start()
    {
        Canvas canvas = GetComponentInParent<Canvas>();
        canvasRect = canvas.transform as RectTransform;
        rectTransform = transform as RectTransform;
        imageHeight = rectTransform.sizeDelta.y;
        List<float> newPosY = new List<float>();

        for (int i = 0; i < transformPos.Count; i++)
        {
            newPosY.Add(posYCoeficient[i] * imageHeight);
            transformPos[i].anchoredPosition = new Vector2(transformPos[i].anchoredPosition.x, newPosY[i]);
        }
    }

    [ContextMenu("SetStartPosition")]
    public void SetStartPosition()
	{
        posYCoeficient.Clear();
        Canvas canvas = GetComponentInParent<Canvas>();
        canvasRect = canvas.transform as RectTransform;
        rectTransform = transform as RectTransform;
        imageHeight = rectTransform.sizeDelta.y;

        for (int i = 0; i < transformPos.Count; i++)
        {
            posYCoeficient.Add(transformPos[i].anchoredPosition.y / imageHeight);
        }
    }

}
