using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ChangeDecal : MonoBehaviour
{
    [SerializeField] private GameObject cube;
    [SerializeField] private Renderer renderer;

	private void Awake()
	{
        if(cube == null)
		{
            cube = this.gameObject;
        }
        if (renderer == null)
        {
            var renderer = cube.GetComponent<Renderer>();
        }
    }

    public void SetDecal(Color color, Texture texture)
	{
        renderer.material.SetColor("_Color", color);
        renderer.material.mainTexture = texture;
    }

    public void SetMainDecal(Color color, Texture texture)
    {
        //renderer.material.SetFloat("_USENORMALMAP", 1f);
        //_USENORMALMAP
        renderer.material.SetColor("_Color", color);
        renderer.material.SetTexture("_NormalMap", texture);
    }

    public void SetAllDecal(Color color, Texture texture)
    {
        //renderer.material.SetFloat("_USENORMALMAP", 1f);
        //_USENORMALMAP
        renderer.material.SetColor("_Color", color);
        renderer.material.mainTexture = texture;
        renderer.material.SetTexture("_NormalMap", texture);
    }

    public void SetDecal(Color color, Sprite sprite)
    {
        renderer.material.SetColor("_Color", color);
        renderer.material.mainTexture = sprite.texture;
    }

    public void ReturnToPool()
	{
        PoolDecal.Instance.ReturnToPool(this);
	}

}
