using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

//[CreateAssetMenu(fileName = "Data", menuName = "LevelObject", order = 1)]
[Serializable]
public class LevelObject : MonoBehaviour
{
	[SerializeField] public string Name;
	[SerializeField] public Skins skinLevel;
	[SerializeField] private bool completed = false;
	[SerializeField] private float distanceToFinish;
	[SerializeField] private float speedPlayer;
	[SerializeField] private float speedRotationPlayer;
	[SerializeField] private bool wasLoaded = false;

	[SerializeField] private float distanceEnabled = 7f;
	[SerializeField] private List<GameObject> allBoxes;
	private Camera camera;
	private int count = 0;



	private void Awake()
	{
		camera = Camera.main;
		count = allBoxes.Count;
	}


	//[SerializeField] private List<Material> materials = new List<Material>();
	//FastRandom rand = new FastRandom();
	//[ContextMenu("SetRandMaterial")]
	//public void SetRandMaterial()
	//{
	//	for (int i = 0; i < allBoxes.Count; i++)
	//	{
	//		rand.NewSeed();
	//		allBoxes[i].GetComponent<MeshRenderer>().sharedMaterials[0] = materials[rand.Range(0, materials.Count - 1)];
	//	}

	//}

	[ContextMenu("LevelSetttings")]
	public void Settings()
	{
		allBoxes.Clear();
		Name = transform.gameObject.name;
		var transallBoxes = transform.GetComponentsInChildren<Transform>().ToList();
		for (int i = 1; i < transallBoxes.Count; i++)
		{
			allBoxes.Add(transallBoxes[i].gameObject);
		}
		//FindObjectsOfType<GameObject>().ToList();
		distanceToFinish = allBoxes.Max(x => x.transform.position.y) + 5.5f;

	}


	private void Update()
	{
		for (int i = 0; i < count; i++)
		{
			if (Mathf.Abs(allBoxes[i].transform.position.y - camera.transform.position.y) <= distanceEnabled)
			{
				allBoxes[i].SetActive(true);
			}
			else
			{
				allBoxes[i].SetActive(false);
			}
		}
	}

	public void SaveCompleted()
	{
		completed = true;
		PlayerPrefs.SetInt(Name, BoolToInt(completed));
	}

	public bool GetCompleted()
	{
		if (!wasLoaded)
		{
			completed = IntToBool(PlayerPrefs.GetInt(Name, 0));
			wasLoaded = true;
		}
		return completed;
	}

	public Tuple<float, float, float> GetLevelSettings()
	{
		return new Tuple<float, float, float>(distanceToFinish, speedPlayer, speedRotationPlayer);
	}

	private int BoolToInt(bool val)
	{
		if (val)
			return 1;
		else
			return 0;
	}

	private bool IntToBool(int val)
	{
		if (val != 0)
			return true;
		else
			return false;
	}

}


