using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using static MenuObject;

public class MainMenu : Menu<MainMenuButtons>
{
    private MenuButton<MainMenuButtons> switchSound;

    public int ThisLevel { get; private set; }

    private void Start()
    {
        switchSound = GetMenuButton(MainMenuButtons.Music);
                
        switchSound.SetListner(() => SwitchSound());

        if(PlayerPrefs.GetInt("fx", 1) == 0 ? false : true)
		{
            switchSound.SwitchOnOff(true);
            SoundManager.StartEndFxPlay(true);
        }
        else
		{
            switchSound.SwitchOnOff(false);
            SoundManager.StartEndFxPlay(false);
        }
    }

    public void SwitchSound()
	{
        SoundManager.PlaySound(SoundManager.Sound.Button);
        switchSound.SwitchOnOff();
        bool change = PlayerPrefs.GetInt("fx", 1) == 0 ? false : true;
        SoundManager.StartEndFxPlay(!change);
    }

	private void OnEnable()
	{
        EventDispatcher.SendEvent(EventNames.OpenMainMenu);
	}


    #region ContextComand
    [ContextMenu("FindeMenuButtons")]
	public override void FindeMenuButtons()
	{
		base.FindeMenuButtons();
	}
	#endregion
}


public enum MainMenuButtons
{
    Play,
    Exit,
    Music,
}
