using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class MessageText : MonoBehaviour
{
	[SerializeField] private Text textForMessage;
	[SerializeField] private string winGameText = "  )";
	[SerializeField] private string looseGameText = "  (";
	[SerializeField] private float secondVisible = 2f;
	[SerializeField] private GameObject winGameImage;

	private void Awake()
	{
		if (textForMessage == null)
		{
			textForMessage = GetComponent<Text>();
		}
		EventDispatcher.Add(EventNames.SetText, SetText);

		//EventDispatcher.Add(EventNames.WinGame, () =>
		//{
		//	object[] texts = new object[1] { winGameText };
		//	SetText(texts);
		//});

		EventDispatcher.Add(EventNames.TextWin, () =>
		{
			object[] texts = new object[1] { winGameText };
			SetText(texts);
			winGameImage.SetActive(true);
		});
		EventDispatcher.Add(EventNames.LoseGame, () =>
		{
			object[] texts = new object[1] { looseGameText };
			SetText(texts);
		});
		EventDispatcher.Add(EventNames.StartGame, () => 
		{
			textForMessage.gameObject.SetActive(false);
			winGameImage.SetActive(false);
		});
		EventDispatcher.Add(EventNames.ResetedLevel, () =>
		{
			textForMessage.gameObject.SetActive(false);
			winGameImage.SetActive(false);
		});

	}

	private void SetText(object[] paremetrs)//string textMessage, float timeVisivle)
	{
		string textMessage = (string)paremetrs[0];
		//float timeVisivle = (float)paremetrs[1];

		textForMessage.gameObject.SetActive(true);
		textForMessage.text = textMessage;
		this.WaitSecond(secondVisible, () =>
		{
			textForMessage.gameObject.SetActive(false);
		});
	}

}
