﻿using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Audio;
using UnityEngine.UI;
//using static MenuObject;
using UnityEngine.EventSystems;
public class SoundManager : MonoBehaviour
{
	[SerializeField] private List<AudioSource> fxSources;
	public static List<AudioSource> _fxSources;
	[SerializeField] private SoundClips soundClips;
	public static SoundClips _soundClip;
	private static AudioClip _button;

	private void Awake()
	{
		_soundClip = soundClips;
		_fxSources = fxSources;
	}

	private void Start()
	{
		//fx = PlayerPrefs.GetInt("fx", 1) == 0 ? false : true;
		_button = GetAudioClip(Sound.Button);
	}

	public enum Sound
	{
		Button,
		ExplosionFire,
		ExplosionWater,
		ExplosionIn,
		ExplosionYan,
		ExplosionEarth,
		ExplosionWind,
		ExplosionElectric,
		ExplosionDielectric,
		ExplosionSpirit,
		ExplosionAntiSpirit,
		WinGame,
		LoseGame,
	}

	public static void FxSourceEnbled(bool enabledDisabled)
	{
		foreach (AudioSource item in _fxSources)
		{
			item.enabled = enabledDisabled;
		}
	}

	public static void StartEndFxPlay(bool what)
	{
		if (what)
		{
			PlayerPrefs.SetInt("fx", 1);
		}
		else
		{
			PlayerPrefs.SetInt("fx", 0);
		}

		FxSourceEnbled(what);
	}

	private static AudioSource GetFreeSource()
	{
		return _fxSources.Find(x => !x.isPlaying);
	}

	private static AudioSource GetNoFreeSource()
	{
		return _fxSources.Find(x => x.isPlaying);
	}

	public static void PlaySound(Sound sound)
	{
		//GameObject soundGameObject = new GameObject("Sound");
		AudioSource source = GetFreeSource();
		//Debug.Log(source.priority.ToString());
		if (source != null)
		{
			source.PlayOneShot(GetAudioClip(sound));
		}
		else
		{
			source = GetNoFreeSource();
			source.PlayOneShot(GetAudioClip(sound));
		}

	}
	public static void PlaySound(AudioClip clip)
	{
		AudioSource source = GetFreeSource();
		if (source != null)
		{
			source.PlayOneShot(clip);
		}
		else
		{
			source = GetNoFreeSource();
			source.PlayOneShot(clip);
		}
	}


	public static void PlaySoundIsPlay(Sound sound)
	{
		//GameObject soundGameObject = new GameObject("Sound");
		AudioSource source = _fxSources.Find(x => x.isPlaying && x.clip == GetAudioClip(sound));
		if (source == null)
		{
			source = GetFreeSource();
		}
		if (source != null)
		{
			if (!source.isPlaying)
			{
				source.PlayOneShot(GetAudioClip(sound));
			}
		}
	}

	public static void PlaySoundIndSource(Sound sound, bool last = false, int index = 1)
	{
		AudioSource source;
		if (last)
		{
			source = _fxSources.Last();
		}
		else
		{
			source = _fxSources[index];
		}
		if (source != null)
		{
			if (!source.isPlaying)
			{
				source.PlayOneShot(GetAudioClip(sound));
			}
		}
	}

	public static AudioClip GetAudioClip(Sound sound)
	{
		foreach (SoundClips.SoundAudioClip soundAudioClip in _soundClip.soundAudioClipArray)
		{
			if (soundAudioClip.sound == sound)
			{
				return soundAudioClip.audioClip;
			}
		}
		Debug.LogError("Sound " + sound + " not found!");
		return null;
	}

	
	public static void ButtonSound()
	{
		PlaySound(_button);
	}


	[ContextMenu("SetAudioSources")]
	public void SetaudSetAudioSourcesioSources()
	{
		fxSources = FindObjectsOfType<AudioSource>().Where(x => x.loop == false).ToList();
	}
}
