using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RotateAround : MonoBehaviour
{
    [SerializeField] private Transform target;
    [SerializeField] private float speedRotation = 5f;
    [SerializeField] private Vector3 rotateVector;
    [SerializeField] private bool restRotation = true;
    private Quaternion rotation;
    private Vector3 position;

    void Start()
    {
        if (target == null)
        {
            target = transform;
        }

        rotation = transform.rotation;
        position = transform.position;

        if (restRotation)
        {
            EventDispatcher.Add(EventNames.ResetedLevel, () =>
            {
                transform.rotation = rotation;
                transform.position = position;
            });
        }
       
	}

    // Update is called once per frame
    void Update()
    {
        //var rotate = Quaternion.AngleAxis(speedRotation, rotateVector);
        //transform.rotation *= rotate;
        transform.RotateAround(target.transform.position, rotateVector, speedRotation * Time.deltaTime);
    }
}
