using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PoolDecal : PoolObject<ChangeDecal>
{
	//[SerializeField] private List<Sprite> decalSprites;
	[SerializeField] private Transform parentDecal;
	[SerializeField] private List<Texture2D> decalTextures;
	//private List<ChangeDecal> InstantiatedDecal = new List<ChangeDecal>();
	private FastRandom random = new FastRandom();


	private void Start() 
	{
		EventDispatcher.Add(EventNames.ExitPlay, () => { ReturnAll(); });
		EventDispatcher.Add(EventNames.WinGame, () => { ReturnAll(); });
	}

	public ChangeDecal GetDecal(Vector3 position, Transform parent, Quaternion rotation, Color color, Sprite sprite)
	{
		var overided = Get(position, parent, rotation);
		overided.SetDecal(color, sprite);
		//InstantiatedDecal.Add(overided);
		return overided;
	}

	public ChangeDecal GetDecal(Vector3 position, Transform parent, Quaternion rotation, Color color, Texture texture)
	{
		var overided = Get(position, parent, rotation);
		overided.SetDecal(color, texture);
		//InstantiatedDecal.Add(overided);
		return overided; 
	}

	public ChangeDecal GetDecal(Vector3 position, Transform parent, Quaternion rotation, Color color)
	{
		var overided = Get(position, parent, rotation);
		overided.SetDecal(color, decalTextures[0]);
		//InstantiatedDecal.Add(overided);
		return overided;
	}

	public ChangeDecal GetDecal(Vector3 position, Transform parent, Color color)
	{
		var overided = Get(position, parent);
		var randDecalInd = random.Range(0, decalTextures.Count-1);
		overided.SetDecal(color, decalTextures[randDecalInd]);
		//InstantiatedDecal.Add(overided);
		return overided;
	}

	public ChangeDecal GetDecal(Vector3 position, Color color)
	{
		var overided = Get(position, parentDecal);
		var randDecalInd = random.Range(0, decalTextures.Count - 1);
		overided.SetDecal(color, decalTextures[randDecalInd]);
		//InstantiatedDecal.Add(overided);
		return overided;
	}

	public ChangeDecal GetDecalMain(Vector3 position, Color color)
	{
		var overided = Get(position, parentDecal);
		var randDecalInd = random.Range(0, decalTextures.Count - 1);
		overided.SetMainDecal(color, decalTextures[randDecalInd]);
		//InstantiatedDecal.Add(overided);
		return overided;
	}

	public ChangeDecal GetDecaled(Vector3 position, Color color)
	{
		var overided = Get(position, parentDecal);
		var randDecalInd = random.Range(0, decalTextures.Count - 1);
		overided.SetAllDecal(color, decalTextures[randDecalInd]);
		//InstantiatedDecal.Add(overided);
		return overided;
	}

	//public void DeleteDecallIns(ChangeDecal deletedDecal)
	//{
	//	deletedDecal.ReturnToPool();
	//}

	//public void DeleteDecall(ChangeDecal deletedDecal)
	//{
	//	ReturnToPool(deletedDecal);
	//}

	//public void ClearAllDecal()
	//{
	//	for (int i = 0; i < InstantiatedDecal.Count; i++)
	//	{
	//		ReturnToPool(InstantiatedDecal[i]);
	//		InstantiatedDecal.Clear();
	//	}
	//}

	//public void ClearAllDecalIns()
	//{
	//	for (int i = 0; i < InstantiatedDecal.Count; i++)
	//	{
	//		InstantiatedDecal[i].ReturnToPool();
	//		InstantiatedDecal.Clear();
	//	}
	//}
}
