using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class ProgressLevel : MonoBehaviour
{
	[SerializeField] private Image progressImage;
	private float distance = 15f;

	public void EndGame()
	{
		progressImage.fillAmount = 1;
	}

	public void StartGame(float distances)
	{
		progressImage.fillAmount = 0;
		distance = distances;
	}

	public void ResetFillAmount()
	{
		progressImage.fillAmount = 0;
	}

	public void SetProgress(float currentDistance)
	{
		progressImage.fillAmount = Mathf.InverseLerp(0, distance, currentDistance);
	}

}
