using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using UnityEngine;

public class SaveSystem : MonoBehaviour
{
	private static string partPathSave = Application.persistentDataPath + "/";
	public static void Save<T>(string nameSave, T level)
	{
		try
		{
			string pathSave = partPathSave + nameSave + ".data";
			BinaryFormatter formatter = new BinaryFormatter();
			FileStream stream = new FileStream(pathSave, FileMode.Create);
			T levelData = (T)Activator.CreateInstance(typeof(T), level);

			formatter.Serialize(stream, levelData);
			stream.Close();
		}
		catch (Exception ex)
		{
			throw new NotSupportedException();
		}
	}

	public static T Load<T>(string nameSave)
		where T : class, new()
	{
		string pathSave = partPathSave + nameSave + ".data";
		if (File.Exists(pathSave))
		{
			BinaryFormatter formatter = new BinaryFormatter();
			FileStream stream = new FileStream(pathSave, FileMode.Open);
			T levelData = formatter.Deserialize(stream) as T;
			stream.Close();
			return levelData;
		}
		else
		{
			return default(T);
			//T levelData = (T)Activator.CreateInstance(typeof(T), 0);
			//return levelData;
		}
	}
}
